var tab = [
    {d:0,  h:"0101"},
    {d:1,  h:"1111"},
    {d:2,  h:"0010"},
    {d:2,  h:"0001"},
    {d:0,  h:"0110"},
    {d:-1, h:""    },
    {d:-1, h:""    },
    {d:0,  h:"0010"},
    {d:-1, h:""    },
    {d:-1, h:""    },
    {d:0,  h:"0010"},
    {d:0,  h:"1010"},
    {d:1,  h:"0101"},
    {d:2,  h:"1101"},
    {d:1,  h:"1110"},
    {d:1,  h:"0000"},
    {d:0,  h:"1110"},
    {d:-1, h:""    }
];

var targ = [];
for (var i=0; i<15; i++) targ[i] = {d:i, h:"0001"};
targ[15] = {d:-1, h:""};

function hcolor(h) { return h==="" ? "#999" : d3.interpolateWarm(parseInt(h,2)/15); }
function dcolor(d) { return d<0 ? "#999" : d3.interpolateBlues(0.4+d/(3+d/0.5)); }

var defs= d3.select("#svg").append("defs"),
    svg = d3.select("#svg").append("g").attr("transform", "scale(2)");

function addBoxes(vals, getx, y) {
    return svg.selectAll()
        .data(vals)
        .enter().append("g")
        .attr("transform", (v,i) => "translate("+getx(i)+","+y+")");
}
function addVals(vals, getx, y, w, h) {
    var src = addBoxes(vals,getx,y);
    src.append("rect")
        .attrs({x:0, y:0, width:w/2, height:h, fill:v=>dcolor(v.d)});
    src.append("rect")
        .attrs({x:w/2, y:0, width:w/2, height:h, fill:v=>hcolor(v.h)});
    src.append("text")
        .attrs({x:w/4, y:4+h/2, "text-anchor":"middle", "font-size":12})
        .text(v => v.d);
    src.append("text")
        .attrs({x:w/2+w/4, y:3+h/2, "text-anchor":"middle", "font-size":8})
        .text(v => v.h);
}
function addEq(vals, getx, y, w, h) {
    var src = addBoxes(vals,getx,y);
    src.append("rect")
        .attrs({x:0, y:0, width:w, height:h, fill:(v,i)=>i==2?"#1c0":"#ccc"});
    src.append("text")
        .attrs({x:w/2, y:4+h/2, "text-anchor":"middle", "font-size":12})
        .text((v,i)=>i==2?-1:0);
}

var h0 =  42,
    h1 =  92,
    h2 = 142;
var x = i=>36+48*i;

svg.append("rect").attrs({x:35+48*2 , y:h0-1, width:48, height:h2-h0+18, fill:"#dfd"});
svg.append("rect").attrs({x:35+48*15, y:h0-1, width:84, height:h2-h0+18, fill:"#ece0d8"});
svg.append("rect").attrs({x:35, y:h0-1, width:16*48, height:18, stroke:"black", "stroke-width":1, fill:"none"});
svg.append("rect").attrs({x:35, y:h1-1, width:16*48, height:18, stroke:"black", "stroke-width":1, fill:"none"});

addVals(tab , i=>x(i-1), h0, 46, 16);
addVals(targ, x, h1, 46, 16);
addEq  (targ, x, h2, 46, 16);

svg.append("text").attrs({x:40, y:h0-4, fill:"#333", "font-size":14}).text("16 bytes from offset table");
svg.append("text").attrs({x:40, y:h1-4, fill:"#333", "font-size":14}).text("Target offset and hash");
svg.append("text").attrs({x:35+8*48, y:h2+33, "text-anchor":"middle", fill:"#282828", "font-size":15}).text("Vector equality test");
svg.append("text").attrs({x:59+15*48, y:h2+30, "text-anchor":"middle", fill:"#443", "font-size":14}).text("Ignore");

svg.append("path")
    .attr("stroke", "#444")
    .attr("fill", "none")
    .attr("d", d3.line()(
        [[x(0),0],[x(0)+1,5],[x(4)-3,5],[x(4)-2,0]].map(p=>[p[0],h2+20+p[1]])
    ));
svg.append("text")
    .attrs({x:x(2)-1, y:h2+40, "text-anchor":"middle", fill:"#444", "font-size":12})
    .text("Normal probing checks all these");


defs.selectAll().data([[1,0.3],[0.3,1]]).enter()
    .append("linearGradient").attr("id", (_,i)=>"edge"+i)
    .selectAll().data(i=>i).enter().append("stop")
    .attrs((e,i)=>({"stop-color": "white", offset:i, "stop-opacity":e}));

svg.selectAll().data([0,x(16)]).enter()
    .append("rect")
    .attrs({x:x=>x, y:0, width:x(0)-2, height:h2+20, "fill":(_,i)=>"url(#edge"+i+")"});
