var i0  =     185,
    i1  = i0 +400,  it = 0.8*i0 + 0.2*i1,  ir = (i1+i0)/2,
    i2  = i1 +360,  ih0= i1-54,  ih = i1+110;

var j0 =     80,
    s  =     80,
    j1 = s +200,
    j2 = j1+200,
    f  = j2+ 50;

var reg   = "black",
    vec   = "#a8233b", vecbg = "#f6e8eb",
    load  = "#406ac2", loadt = "#2455bd";

var svg = d3.select("#svg");
svg.append("defs").selectAll().data([reg,vec]).enter()
    .append("marker").attrs({
        viewBox:"0 0 7 5", markerWidth:5, markerHeight:5,
        orient:"auto", refX:4.2, refY:2.5, fill:c=>c,
        id:(_,i)=>"arrow"+i
    })
    .append("path").attr("d","M0 0L7 2.5L0 5");

var targ   = [it, j0],
    hash0  = [ih0,j0],
    hash   = [ih, j0],
    geti   = [i0, j1],
    comp   = [i1, j1],
    append = [i2, j1];

var lines = svg.selectAll().data([
        [targ  , geti  ,  reg,  0.63],
        [targ  , comp  ,  vec,  0.69],
        [hash  , comp  ,  vec,  0.63],
        [geti  , comp  ,  reg,  0.75],
        [comp  , append,  vec,  0.72],
    ].map(d=>({x1:d[0][0], x2:d[0][0]+d[3]*(d[1][0]-d[0][0]),
               y1:d[0][1], y2:d[0][1]+d[3]*(d[1][1]-d[0][1]),
               stroke:d[2]}))).enter().append("g");
lines.append("line")
    .attr("stroke-width", 5)
    .attr("stroke-linecap", "round")
    .attr("marker-end", l=>"url(#arrow"+(l.stroke===vec?1:0)+")")
    .attrs(l=>l);

svg.append("ellipse")
    .attrs({cx:i2+96, cy:j1, rx:84, ry:230, stroke:vec, "stroke-width":5, fill:"none"});
svg.append("path")
    .attrs({d:[[0,0],[7,2.5],[0,5]].map((d,i)=>"MLL".charAt(i)+(4*d[1]+i2+169.5)+" "+(j1+5-4*d[0])), fill:vec});
svg.append("text")
    .attrs({transform: "translate("+(i2+165)+","+j1+")rotate(-90)",
            "text-anchor":"middle", "font-size":34, fill:vec})
    .text("Results");

function getbox(d) {
    var w=d.w, h=42*d.text.length;
    return {x:d.x-w/2, y:d.y-h/2, width:w, height:h,
            "stroke-width":2, stroke:"black",
            fill : d.load ? "#dce4f5" : "#eee"};
    return a;
}

var boxes = svg.selectAll().data([
        {text:"Target/array"            , pos:targ  , w:114, load:1},
        {text:"Byte/table"              , pos:hash0 , w:114, load:1},
        {text:"Hash/table"              , pos:hash  , w:114, load:1},

        {text:"Compute/hash-based/index", pos:geti  , w:220},
        {text:"Load/and/compare"        , pos:comp  , w:180},
        {text:"Append/to result/vector" , pos:append, w:180},

        {text:"Index/into hash" , pos:[(i0+i1)/2  ,j1], w:200, norect:1},
        {text:"Boolean/result"  , pos:[(i1+i2)/2-4,j1], w:200, norect:1, fill:vec},
    ].map(d=>{d.text=d.text.split("/"); d.x=d.pos[0]; d.y=d.pos[1]; return d})).enter();
boxes.append("rect").filter(d=>d.norect!==1)
    .attrs(getbox);
boxes.selectAll().data(d=>
        d.text.map((t,i)=>({text:t, x:d.x, y:d.y+42*(i-(d.text.length-1)/2), fill:d.fill}))
    ).enter()
    .append("text")
    .attr("text-anchor", "middle")
    .attrs(d=>{
        var fs=34,
            a = {x:d.x, y:d.y+fs/3, fill:d.fill, "font-size":fs};
        return a;
    })
    .text(d=>d.text);

svg.selectAll().data([-1,1]).enter()
    .append("line").attrs(d=>({
        x1:hash0[0]-d*66, x2:hash0[0]+d*66,
        y1:hash0[1]-  50, y2:hash0[1]+  50,
        "stroke-width":3, stroke:"black"
    }));

svg.append("rect")
    .attrs({x:232, y:396, width:172, height:84, fill:"#f6f8ff",
            opacity:0.96,
            "stroke-width":3, stroke:"#aaa"});
var legend = svg.selectAll().data([reg,vec]).enter()
    .append("g").attr("transform",(_,i)=>"translate(290,"+(430+38*i)+")");
legend.append("line").attrs({x1:-40,x2:-12,y1:-12,y2:-12,
                           "stroke-width":5, stroke:c=>c, "stroke-linecap":"round"});
legend.append("text")
    .attr("font-size",32)
    .attr("fill",c=>c)
    .text((_,i)=>["Scalar","Vector"][i]);
svg.append("rect")
    .attrs({x:231, y:395, width:174, height:86, fill:"white",
            opacity:0.12});
