function eq(v) { return v.map(e=>({v:e, c:e?"#1c0":"#ccc"})); }

function trans(getx,y) { return (_,i) => "translate("+getx(i)+","+y+")"; }

// (?--:)2^2+8?@:$25
var srcs = [
    [  -185, "#a4f1a0"], [218917, "#c1f4ea"], [ -1657, "#acddd5"], [  -161, "#bbbede"],
    [ 30236, "#bca7ad"], [    56, "#e0adbf"], [   174, "#a4c0b1"], [     1, "#f8baae"]
].map(e=>({v:e[0], c:e[1]}));

var h1 =  20,
    h2 =  90,
    h3 = 160,
    h4 = h1+30,
    xoff = 150,//72,
    xl = i=>xoff+100*i,  tl = trans(xl,h2),
    xs = i=>100*i,       ts = trans(xs,0);

var s0   = d3.select("#svg").append("g").attr("transform", "scale(2)"),
    back = s0.append("g"),
    fore = s0.append("g"),
    svg  = s0.append("g");

fore.append("defs")
    .selectAll().data([[1,0.5],[0.5,1]]).enter()
    .append("linearGradient").attr("id", (_,i)=>"fadeGradient"+i)
    .selectAll().data(d=>d).enter().append("stop")
    .attrs((e,i)=>({offset:i, "stop-color": "white", "stop-opacity":e}));
fore.selectAll().data([0,6*68]).enter()
    .append("rect").attrs({x:x=>x, y:h3-5, width:2*68, height:40,
                           "fill":(_,i)=>"url(#fadeGradient"+i+")"});

var lines = back.selectAll().data([
        [h3, h2, 0.68*xs(4  ), [xl(2  )]],
        [h3, h4, 0.68*xs(2.5), [xl(-0.8)]],
        [h2, h1, xl(0.5)     , [0,1,2,3].map(i=>xl(i+0.5))]
    ]).enter()
    .selectAll().data((d,i)=>d[3].map(x2=>({y1:d[0]+5,y2:d[1]+25,x1:d[2],x2:x2,class:"line"+i}))).enter()
    .append("line")
    .attrs(d=>d)
    .attrs({"stroke-width":2, stroke:"black", opacity:0});

function addVals(base, vals, tr) {
    var g = base.selectAll()
        .data(vals)
        .enter().append("g")
        .attr("transform", tr);
    var w = 100, h = 32, font = 20;
    g.append("rect")
        .attrs({x:0, y:0, width:w, height:h, fill:p=>p.c});
    g.append("text")
        .attrs({x:w/2, y:font/3+h/2, "text-anchor":"middle", "font-size":font})
        .text(p=>p.v);
    return g;
}

function addSrc(a,b, base) {
    var tf = "translate("+xs(a)*0.68+","+h3+")scale(0.68)";
    var g = (base||svg).append("g").attr("transform",tf);
    addVals(g, srcs.slice(a,b), trans(i=>xs(i), 0));
    return g;
}

addSrc(0,8, back);

svg.append("path")
    .attrs({d:[[0,0],[7,2.5],[0,5]].map((d,i)=>"MLL".charAt(i)+(2*d[1]+0.68*xs(2.5))+" "+(h3+35-2*d[0])),
            opacity:0});

var li = 0;
function move(g, tr) {
    g.transition().duration(800).attr("transform", tr);
    lines.filter(d=>d["class"]==="line"+li).transition().delay(600).duration(400)
        .attr("opacity",1);
    li++;
}

var targ, hash;
var step = 0;
document.onclick = function() {
    switch (step++) {
        case 0:
            move(addSrc(2,6), "translate("+xl(0)+","+h2+")");
            break;
        case 1:
            svg.select("path").transition().duration(600).attr("opacity",1);
            break;
        case 2:
            move(addSrc(2,3), "translate("+xl(-1.3)+","+h4+")");
            break;
        case 3:
            var v0 = []; for (var i=0; i<4; i++) v0[i] = srcs[2];
            targ = addVals(svg, v0, trans(i=>xl(0), h2));
            move(targ, trans(xl, h1));
            break;
    }
}
