var dirty = "#cac4ba",
    equal = "#1c0",
    color = c => c==="1"?equal:"#eee";

var sub = [
    "0001", "1000", "0010", "0000", "0001", "0001", "0010", "1000",
    "0000", "0100", "0100", "0010", "0001", "0000", "0000", "0000",
    "0010", "0000", "0000", "0000", "0010", "0001", "0000", "0000",
    "0000", "0010", "0001", "0000", "0010", "0001", "0010", "0000"
];

var svg = d3.select("#svg");

var width = 1500,
    bw = 10,
    bh = 30,
    pad= 2,
    ww = 2*pad + 32*bw,
    xfromw = w => (width-4*ww)/2 + w*ww,
    xfromb = b => pad + b*bw,
    sep= 180;

var bits = ["", "", "", ""];

var cmp_ti = "translate(100,200)",
    cmp_t0 = "translate(0,0)",
    cmp_tf = "translate(-100,200)";

svg.append("defs").selectAll().data(bits).enter()
    .append("clipPath").attr("id", (_,i)=>"clip"+i)
    .append("rect").attrs({x:pad, y:pad, width:32*bw, height:bh});

var resw = svg.selectAll().data(bits).enter()
    .append("g").attr("transform", (_,w)=>"translate("+xfromw(w)+",30)");
var arrow = resw.append("line")
    .attrs({x1:ww/2, x2:ww-pad-bw/2, y1:sep-bh-2, y2:bh+2*pad+2,
            stroke:"black", "stroke-width":2, "stroke-linecap":"square",
            opacity:0});
resw.append("rect")
    .attrs({x:0, y:0, width:ww, height:2*pad+bh,
            stroke:"black", "stroke-width":4, fill:"none"});

var bitbox = resw
    .append("g").attr("clip-path", (_,i)=>"url(#clip"+i+")")
    .append("g").attr("transform", "translate("+pad+","+pad+")");
bitbox.append("rect")
    .attrs({x:0, y:0, width:32*bw, height:bh, fill:dirty});

var cmp = svg.append("g").attr("transform", cmp_ti);
var cmpw = cmp.selectAll().data(sub[0]).enter()
    .append("g").attr("transform", (_,w)=>"translate("+xfromw(w)+","+sep+")");
cmpw.append("rect")
    .attrs({x:0, y:0, width:ww, height:2*pad+bh,
            stroke:"black", "stroke-width":4});
cmpw.append("text")
    .attrs({x:ww/2, y:pad+8+bh/2, "text-anchor":"middle", "font-size":24})
    .text(c=>-c);

function initstep(newsub) {
    bits.forEach((b,i) => bits[i]+=newsub.charAt(i));
    arrow.data(newsub)
        .attrs(c => c==="1" ? {stroke:equal , "stroke-width":6}
                            : {stroke:"#444", "stroke-width":2});
    cmpw.data(newsub);
    cmpw.select("rect").attr("fill",color);
    cmpw.select("text").text(c=>-c);
}
var bitv;
function shift(del, sh) {
    bitbox.transition().delay(del).attr("transform", "translate("+(pad-bw*sh)+","+pad+")");
    bitv = bitbox.data(bits).selectAll("g").data(b=>b).enter()
        .append("g")
        .attr("transform", (_,b)=>"translate("+((32+b)*bw)+",0)");
    bitv.append("rect").attrs({x:0, y:0, width:bw, height:bh, fill:color("0")});
    bitv.append("text").attrs({x:0, y:5+bh/2, "font-size":15}).text("0");
}
function addBit(del) {
    bitv.select("rect").transition().delay(del+500).attr("fill",color);
    bitv.select("text").transition().delay(del+700).text(c=>c);
    arrow.transition().delay(del).attr("opacity",1)
         .transition().delay(800).attr("opacity",0);
}

async function shiftAll() {
    var sh = 1;
    while (sh<32) {
        initstep(sub[sh++]);
        cmp.attr("transform", cmp_ti)
            .transition()            .duration(800).attr("transform", cmp_t0)
            .transition().delay(1900).duration(600).attr("transform", cmp_tf);
        shift(800, sh);
        addBit(1300);
        await new Promise(resolve => setTimeout(resolve, 3500));
    }
}

var step = 0;
document.onclick = function() {
    switch (step++) {
        case 0:
            initstep(sub[0]);
            cmp.attr("transform", cmp_ti)
                .transition().duration(1000).attr("transform", cmp_t0);
            break;

        case 1:
            shift(0, 1);
            break;

        case 2:
            addBit(0);
            break;

        case 3:
            cmp.transition().duration(1000).attr("transform", cmp_tf);
            break;

        case 4:
            shiftAll();
            break;
    }
}
