function initStr(str, n) {
  var l = [];
  for (var i=0; i<n; i++) { l[i] = {x:i, c:str.charAt(i), v:str.charCodeAt(i)}; }
  return l;
}

var alpha = "EFKMPQTUWZbegly",
    omega = "Q";

var defs= d3.select("#svg").append("defs"),
    svg = d3.select("#svg").append("g").attr("transform", "scale(2)");

var w = 40,
    y0= 16,
    h = 32,
    getx = i => 40 + w*i,
    csplash = "#257",
    cpath = "#012";

var jumps = [
    [7,0,1200],
    [3,0,88],
    [5,1,44],
    [6,1,21],
    [5.5,0,10.5]
];
var end = getx(jumps[4][0]+0.2);

defs.append("linearGradient").attr("id", "fadeLetter")
    .selectAll().data([1,0.9]).enter().append("stop")
    .attrs((e,i)=>({"stop-color": "white", offset:i, "stop-opacity":e}));
defs.append("linearGradient").attr("id", "fadeSplash")
    .selectAll().data([1,0]).enter().append("stop")
    .attrs((e,i)=>({"stop-color": csplash, offset:i, "stop-opacity":e}));
defs.append("mask").attr("id","mask")
    .append("rect").attrs({x:0,y:0,width:w,height:h,fill:"url(#fadeLetter)"});
defs.append("rect").attrs({id:"splash", x:0, y:0, width:w*0.7, height:1, fill:"url(#fadeSplash)"});

var spl = svg.selectAll().data(jumps.slice(1)).enter()
    .append("g")
    .attr("transform",(j,i)=>"translate("+getx(jumps[i][0]+0.2)+","+(y0+h)+")"
                            +"scale("+(j[1]?1:-1)+","+(8+j[2]/3)+")");
spl.append("linearGradient")
    .attrs({x2:0.7, y2:1, id:(_,i)=>"fadeVert"+i})
    .selectAll().data((_,i)=>[0.5+i/14,0]).enter().append("stop")
    .attrs((e,i)=>({"stop-color": "white", offset:0.6*i, "stop-opacity":e}));
spl.append("mask").attr("id", (_,i)=>"mask"+i)
    .append("rect").attrs({x:0,y:0,width:w,height:1,fill:(_,i)=>"url(#fadeVert"+i+")"});
spl.append("use").attr("xlink:href","#splash")
    .attr("mask", (_,i)=>"url(#mask"+i+")");

svg.append("path").attr("stroke",cpath)
    .attrs({fill:"none", "stroke-linecap":"round", "stroke-linejoin":"round"})
    .attr("d","M329 120"+
        jumps.map(j=>"A"+[j[2],j[2],0,0,1-j[1],getx(j[0]+0.2),y0+h].join(" ")).join()
    );

function addChars(vals, getx, y, w, h, mid) {
    var chars = svg.selectAll()
        .data(vals)
        .enter().append("g")
        .attr("transform", (_,i) => "translate("+getx(i)+","+y+")");
    var rect = chars.append("rect")
        .attrs({x:0, y:0, width:w, height:h})
        .attr("fill", c => d3.interpolateWarm(1-(c.charCodeAt(0)-64)/52));
    if (!mid) rect.attr("mask", "url(#mask)");
    chars.append("text")
        .attrs({x:mid?w/2:1, y:6+h/2, "text-anchor":mid?"middle":"start", "font-size":"20"})
        .text(c => c);
    return chars;
}

var list= addChars(alpha, getx,    y0,  w,  h, 0);
var src = addChars(omega, i=>300, 116, 60, 48, 1);

//list.filter(c=>c===omega).raise().select("rect")
//    .attrs({stroke:"black", "stroke-width":1});
svg.append("line").attrs({x1:end,x2:end,y1:y0-1,y2:y0+h,stroke:cpath});
svg.selectAll().data(" "+alpha).enter()
    .append("text")
    .attrs((_,i)=>({x:getx(i?i-0.3:-0.2), y:y0-(i?5:4), "text-anchor":"middle", "font-size":"14"}))
    .text((_,i) => i);
