function initStr(str, n, o) {
  var l = [];
  for (var i=0; i<n; i++) { l[i] = {x:i+o, c:str.charAt(i), v:str.charCodeAt(i)}; }
  return l;
}

// /:~ +&(15(](]+(32-[)*<:)(?2&*))26)&.(a.&i.) 'A'
var alpha = initStr("EFKMPQTUWZbegly", 15, 1);
alpha.push({x:0, c:' ', v:-1});

// +&(16(](]+(32-[)*<:)(?@:$2&*))26)&.(a.&i.) 'A'
var omega = initStr("EQiNDDFX", 8, 0); // "ETiNDDFXVFnHKtkl"

// [4,2,1,0].map(i=>[0,1].map(j=>d3.lab(d3.schemePaired[2*i+j]).brighter(j?0:0.6)))
var bitcolors = [
        ["#e8d0f5", "#8b09d6"],
        ["#ffb8b6", "#c22530"],
        ["#d0fea7", "#4b9e46"],
        ["#c4ecff", "#1f7fbf"]
    ],
    bw = c => ["#f8f8f8", "#555"][c],
    front = "#111";

function color(p) { return p.v<0 ? "#888" : d3.interpolateWarm(1-(p.v-64)/52); }

var defs= d3.select("#svg").append("defs"),
    svg = d3.select("#svg").append("g").attr("transform", "scale(2)");
defs.append("radialGradient").attr("id", "fadeCirc")
    .selectAll().data([[0.2,1],[0.6,0.7],[1,0]]).enter()
    .append("stop")
    .attrs(e=>({"stop-color": "white", offset:e[0], "stop-opacity":e[1]}));
defs.selectAll().data([["S",3],["L",7]]).enter()
    .append("mask").attr("id",m=>"mask"+m[0])
    .append("circle").attrs({cx:0, cy:0, r:m=>m[1], fill:"url(#fadeCirc)"});

function addChars(vals, getx, y, w, h) {
    var chars = svg.selectAll()
        .data(vals)
        .enter().append("g")
        .attr("transform", p => "translate("+getx(p.x)+","+y+")");
    chars.append("rect")
        .attrs({x:0, y:0, width:w, height:h})
        .attr("fill", color);
    chars.append("text")
        .attrs({x:w/2, y:6+h/2, "text-anchor":"middle", "font-size":"20"})
        .text(p => p.c);
    return chars;
}

function getbndx(i) { return 40 + 40*i; }
var list= addChars(alpha, getbndx,      20, 40, 32);
var src = addChars(omega, i=>120+60*i, 180, 60, 48);

function get4bits(i) { return (16+i).toString(2).slice(1); }

function fillBits(g, getx, yo, r, corner, size, rcolor, ccolor) {
    var lbox = g.selectAll().data(get4bits).enter().append("g")
        .attr("transform", (c,i)=>"translate("+(getx(i)+r)+","+(-r-yo)+")");
    lbox.append("rect")
        .attrs({x:-r, y:-r, rx:corner, ry:corner, width:2*r, height:2*r,
                fill: rcolor});
    var circ = lbox.append("circle")
        .attrs({cx:0, cy:0, r:r, mask:"url(#mask"+size+")"});
    if (ccolor) circ.attr("fill", ccolor);
    else        circ.attr("opacity", 0);
}

var llabel = list.append("g").datum(p=>p.x);
fillBits(llabel, i=>6*i,0, 3, 1, "S", bw, (c,i)=>bitcolors[i][c]);
llabel.append("text")
    .attrs({x:12, y:-9, "text-anchor":"middle", "font-size":"14"})
    .text(i => i);

var csplash = "#257",
    cpath = "#012";

var bitn = 0;
var slabel = src.append("g").datum(p=>8);
fillBits(slabel, i=>6+12*i,3, 6, 3.5, "L", c=>["#ccc",front][c]);
slabel.append("text")
    .attrs({x:30, y:-18, "text-anchor":"middle", "font-size":"26"})
    .text(i => i);
function getx2(t,i) { return 0.96*(20+getbndx(t)-(120+60*i)); }
slabel.append("line")
    .attrs({stroke:cpath, x1:30, y1:-40, y2:-128})
    .attr("x2", getx2);

defs.append("radialGradient").attr("id", "gradHL")
    .selectAll().data([[0.9,0.5],[1,0]]).enter()
    .append("stop")
    .attrs(e=>({"stop-color": "white", offset:e[0], "stop-opacity":e[1]}));
defs.append("mask").attr("id","maskHL")
    .append("circle").attrs({cx:20,cy:132,r:100,fill:"url(#gradHL)"})
function spl_o(_,i) { var m=1<<(4-bitn); return (i+1)%m === m/2 ? 1-0.15*bitn : 0; }
var splash = list.insert("circle", ":first-child")
    .attrs({cx:20,cy:10,r:30,fill:"#257",mask:"url(#maskHL)"})
    .attr("opacity", spl_o);

svg.selectAll().data(["#333","#666","#888"]).enter()
    .append("rect")
    .attrs({x:(c,i)=>610+18*i, y:199, width:10, height:10, fill:c=>c});

var bit = 8;
document.onclick = function() {
    if (bitn >= 4) return;
    slabel.datum((p,i) => p-Math.ceil(bit/2) + bit*(omega[i].v >= alpha[p-1].v));
    bitn++; bit/=2;
    var dur = 1200;
    var sbox = slabel.selectAll("g").data(get4bits);
    var news = sbox.filter((c,i)=>i<bitn);
    news.select("rect").transition().duration(dur).attr("fill", bw);
    news.select("circle")
        .attr("fill", (c,i)=>bitcolors[i][c])
        .transition().duration(dur).attr("opacity",1);
    sbox.filter((c,i)=>i===bitn).select("rect")
        .transition().duration(dur).attr("fill", front);
    slabel.select("text").text(i => i);
    slabel.select("line").transition().duration(dur).attr("x2", getx2);
    splash.transition().duration(dur).attr("opacity", spl_o);
}
