function initStr(str, n, o) {
  var l = [];
  for (var i=0; i<n; i++) { l[i] = {x:i+o, c:str.charAt(i), v:str.charCodeAt(i)}; }
  return l;
}

var alpha = initStr("FFFFbbbbrrrr", 12, 4);
for (var i=0; i<4; i++) alpha.push({x:i, c:' ', v:-1});

var omega = initStr("AAAAnnnn", 8, 0);

var bitcolors = [
        ["#e8d0f5", "#8b09d6"],
        ["#ffb8b6", "#c22530"],
        ["#d0fea7", "#4b9e46"],
        ["#c4ecff", "#1f7fbf"]
    ],
    bw = (c,i) => (i<2 ? ["#f8f8f8", "#555"] : ["#ccc", "#111"])[c],
    front = "#111";

function color(p) { return p.v<0 ? "#888" : d3.interpolateWarm(1-(p.v-64)/52); }

var defs= d3.select("#svg").append("defs"),
    svg = d3.select("#svg").append("g").attr("transform", "scale(2)");
defs.append("radialGradient").attr("id", "fadeCirc")
    .selectAll().data([[0.2,1],[0.6,0.7],[1,0]]).enter()
    .append("stop")
    .attrs(e=>({"stop-color": "white", offset:e[0], "stop-opacity":e[1]}));
defs.selectAll().data([["S",3],["L",7]]).enter()
    .append("mask").attr("id",m=>"mask"+m[0])
    .append("circle").attrs({cx:0, cy:0, r:m=>m[1], fill:"url(#fadeCirc)"});

function addChars(vals, nums, getx, y, w, h) {
    var chars = svg.selectAll()
        .data(vals)
        .enter().append("g")
        .attr("transform", p => "translate("+getx(p.x)+","+y+")");
    chars.append("rect")
        .attrs({x:0, y:0, width:w, height:h})
        .attr("fill", color);
    svg.selectAll().data(nums).enter()
        .append("text")
        .attrs({x:(_,i)=>getx(2+4*i), y:y+7+h/2, "text-anchor":"middle", "font-size":"20"})
        .text(d=>d);
    return chars;
}

var tw = 60,
    getbndx = i => 40 + 40*i,
    gettarx = i =>120 + tw*i;
// 50 <.@:* (**2^4%~|) 96 -~ a.i.'FbrAn'
var list= addChars(alpha, ["", -4526, 70, 1131], getbndx,  20, 40, 32);
var src = addChars(omega, [-10764, 565],         gettarx, 180, tw, 48);

function get4bits(i) { return (16+i).toString(2).slice(1); }

function fillBits(g, getx, yo, r, corner, size, rcolor, ccolor) {
    var lbox = g.selectAll().data(get4bits).enter().append("g")
        .attr("transform", (c,i)=>"translate("+(getx(i)+r)+","+(-r-yo)+")");
    lbox.filter((_,i)=>i===2).append("rect")
        .attrs({x:-r, y:-r, width:4*r, height:2*r, fill: "#e8e8e8"});
    var rf = i => i<2?r:r-(ccolor?0.7:0.9),
        xy = (_,i) => -rf(i),
        wh = (_,i) => 2*rf(i);
    lbox.append("rect")
        .attrs({x:xy, y:xy, rx:corner, ry:corner, width:wh, height:wh,
                fill: rcolor});
    var circ = lbox.append("circle")
        .filter((_,i)=>i<2)
        .attrs({cx:0, cy:0, r:r, mask:"url(#mask"+size+")"});
    if (ccolor) circ.attr("fill", ccolor);
    else        circ.attr("opacity", 0);
}

var llabel = list.append("g").datum(p=>p.x);
fillBits(llabel, i=>6*i,0, 3, 1, "S", bw, (c,i)=>bitcolors[i][c]);
llabel.append("text")
    .attrs({x:12, y:-9, "text-anchor":"middle", "font-size":"14"})
    .text(i => i);

var bitn = 0;
var slabel = src.append("g").datum((p,i)=>8+i%4);
fillBits(slabel, i=>6+12*i,3, 6, 3.5, "L", c=>["#ccc",front][c]);
slabel.append("text")
    .attrs({x:30, y:-18, "text-anchor":"middle", "font-size":"26"})
    .text(i => i);
function getx2(t,i) { return 0.96*(20+getbndx(t)-gettarx(i)); }
slabel.append("line")
    .attrs({stroke:"#012", x1:30, y1:-40, y2:-128})
    .attr("x2", getx2);

defs.append("radialGradient").attr("id", "gradHL")
    .selectAll().data([[0.9,0.5],[1,0]]).enter()
    .append("stop")
    .attrs(e=>({"stop-color": "white", offset:e[0], "stop-opacity":e[1]}));
defs.append("mask").attr("id","maskHL")
    .append("circle").attrs({cx:20,cy:132,r:100,fill:"url(#gradHL)"})
function spl_o(_,i) { var m=1<<(4-bitn); return (i+1)%m === m/2 ? 1-0.15*bitn : 0; }

svg.selectAll().data(["#333","#666","#888"]).enter()
    .append("rect")
    .attrs({x:(c,i)=>610+18*i, y:199, width:10, height:10, fill:c=>c});

src.filter((_,i)=>i===4).attr("id", "slabel4");
svg.selectAll().data([0,1]).enter()
    .insert("rect", "#slabel4")
    .attrs({x:i=>gettarx(4*(i+1)), y:141, width:4*tw, height:39, fill:"white"})
    .filter(i=>i).raise();

var bit = 8;
document.onclick = function() {
    if (bitn < 2) {
        slabel.datum((p,i) => p-(bitn==1?bit:bit/2) + bit*(omega[i].v >= alpha[p-4].v));
        bitn++; bit/=2;
        var dur = 1200;
        var sbox = slabel.selectAll("g").data(get4bits);
        var news = sbox.filter((c,i)=>i<bitn);
        news.select("rect").transition().duration(dur).attr("fill", bw);
        news.select("circle")
            .attr("fill", (c,i)=>bitcolors[i][c])
            .transition().duration(dur).attr("opacity",1);
        if (bitn<2)
            sbox.filter((c,i)=>i===bitn).select("rect")
                .transition().duration(dur).attr("fill", front);
        slabel.select("text").text(i => i);
        slabel.select("line").transition().duration(dur).attr("x2", getx2);
    } else if (bitn == 2) {
        slabel.select("line").attr("opacity", 1)
            .transition().duration(400).attr("opacity", 0);
        slabel.select("text").attr("opacity", 1);
        slabel.transition().delay(500).duration(2000).ease(d3.easeQuadInOut)
            .attr("transform", "translate("+(tw*3.5)+",0)")
            .select("text").attr("opacity", 0);
        var f = slabel.filter((_,i)=>i%4===0).datum(p=>p/4);
        f.append("text")
            .attrs({x:9, y:-18, "font-size":"26", opacity:0})
            .text(i => i)
            .transition().delay(2600).duration(500).attr("opacity",1);
        f.select("line")
            .transition().delay(1000).duration(0)
            .attrs({x1:15, x2:(t,i)=>getx2(4*t+1.5,4*i+3.5),
                    stroke:"#97b0bd", "stroke-width":2.5,
                    "stroke-dasharray": "7,5", "stroke-linecap":"round"})
            .transition().delay(1800).duration(400).attr("opacity",1);
        bitn++;
    }
}
