var disp = [-1, 0, 1, 2, 2, 0, -1, -1, 0, -1, -1, 0],
    val  = " epboz  q  m";

function vcolor(c) { return c===" " ? "#888" : d3.interpolateWarm(1-(c.charCodeAt(0)-96)/48); }
function dcolor(d) { return d<0 ? "#888" : d3.interpolateBlues(0.4+d/(3+d/0.7)); }

var w = 72,
    h = 30,
    getx = i=>112+72*(i-2);

var tab = disp.map((c,i)=>({c:val.charAt(i), h:i-disp[i], id:i})),
    nextid = tab.length;
function transy(i,y) { return "translate("+getx(i)+","+y+")"; }
function transt(e,i) { return transy(i,10); }

var defs= d3.select("#svg").append("defs"),
    fore= d3.select("#svg").append("g").attr("transform", "scale(2)"),
    svg = fore.append("g");

var insptr = svg.append("line")
    .attrs({x1:getx(6), y1:120, y2:78, stroke:"black", opacity:0});

defs.append("linearGradient").attr("id", "fade")
    .selectAll()
    .data([[0,0],[0.02,0.15],[0.07,1],[0.93,1],[0.98,0.15],[1,0]])
    .enter()
    .append("stop")
    .attrs(e=>({offset:e[0], "stop-color": "white", "stop-opacity":e[1]}));
defs.append("mask").attr("id","fadeEdge")
    .append("rect").attrs({x:0, y:0, width:800, height:220, "fill":"url(#fade)"});
svg.attr("mask", "url(#fadeEdge)");

function addRow(elts, y, color) {
    elts.append("rect")
        .attrs({x:0, y:y, width:w, height:h, fill:color});
    elts.append("text")
        .attrs({x:w/2, y:y+6+h/2, "text-anchor":"middle", "font-size":18})
        .text(c => c===-1?"–":c);
    return elts;
}
function addRows(sel, disp) {
    addRow(sel.append("g").datum(disp),  40, dcolor);
    addRow(sel.append("g").datum(e=>e.c), 0, vcolor);
}

var dur = 1400;
function updatedisp(sel, disp) {
    var dbox = sel.select("g").datum(disp);
    dbox.select("rect").transition().duration(dur)
        .attr("fill", dcolor);
    dbox.select("text").transition().delay(dur/4)
        .text(c => c===-1?"–":c);
}

var elts = svg.selectAll("g")
    .data(tab, e=>e.id);

addRows(elts.enter().append("g").attr("class", "entry").attr("transform", transt),
        (e,i)=>i-e.h);

var targbox = fore.append("rect")
    .attrs({y:10, width:w, height:40+h, fill:"none", stroke:"black", opacity:0});

var upd, add, setpos, collision, hp, j;

function startins(e) {
    e.id = nextid++;
    insptr.attr("x2", getx(e.h+0.5));

    j = hp = e.h;
    while (tab[j].h < hp) j++;
    nprobe = j - hp;

    tab.splice(j, 0, e);
    var k = j;
    while (tab[k].c !== " ") tab[k++].d++;
    tab.splice(k, 1);
    collision = j===k;

    upd = svg.selectAll(".entry").data(tab, e=>e.id);

    add = upd.enter()
        .append("g").attr("class", "entry")
        .attr("transform", transy(5.2,210)).attr("opacity", 0);
    addRows(add, 0);
    add.transition().duration(600)
        .attr("transform", transy(5.5,110)).attr("opacity", 1);

    insptr.transition().delay(800).duration(400).attr("opacity",1);
}

function probe() {
    if (hp++ < j) {
        insptr.transition().duration(500).attr("x2", getx(hp+0.5));
        updatedisp(add, e=>hp-e.h);
        return 0;
    } else {
        targbox.attr("x", getx(hp-1))
            .transition().duration(500).attr("opacity",1)
            .transition().delay(800).attr("opacity",0);
        insptr.transition().delay(1450).attr("opacity",0);
        return 1;
    }
}

function pos(sel, del) {
    sel.raise().transition().delay(del).duration(dur)
        .attr("transform", transt);
}

function insert1() {
    pos(upd, 0);
    updatedisp(upd, (e,i)=>i-e.h);

    var del = collision ? 600 : 0;
    pos(add, del);

    upd.exit()
        .transition().delay(dur+del)
        .remove();
}

var inserts = [
    {c:"i", h:9},
    {c:"g", h:2},
//  {c:"w", h:5}
];

var step = 0,
    substep = 0;
document.onclick = function() {
    if (step >= inserts.length) return;
    switch (substep++) {
        case 0: startins(inserts[step]); break;
        case 1: if (!probe()) substep--; break;
        case 2: insert1(); step++; substep=0; break;
    }
}
