var ir  =      40,
    i0  = ir +240,
    i1  = i0 +400,
    i2  = i1 +160;

var j1 =    100,
    j2 = j1+160,
    js = [j1,j2];

var reg   = "black",
    vec   = "#a8233b", vecbg = "#f6e8eb",
    load  = "#406ac2", loadt = "#2455bd";

var svg = d3.select("#svg");
svg.append("defs")
    .append("marker").attrs({
        viewBox:"0 0 7 5", markerWidth:5, markerHeight:5,
        orient:"auto", refX:4.2, refY:2.5, fill:"black",
        id:(_,i)=>"arrow"
    })
    .append("path").attr("d","M0 0L7 2.5L0 5");

var w      = i => [i2,js[i]],
    g      = i => [i1,js[i]],
    r      = i => [i0,js[i]],
    e      = i => [ir,js[i]],
    int0   = i => [(i1+i2)/2, js[i]-30],
    int1   = i => [(i0+i1)/2, js[i]-30],
    int2   = i => [(ir+i0)/2, js[i]-30];

var lines = svg.selectAll().data([
        [w(0), g(0)],
        [w(1), g(1)],
        [g(0), r(0)],
        [g(1), r(1)],
        [r(0), e(0)],
        [r(1), e(1)],
    ].map(d=>({x1:d[0][0], x2:d[1][0]+40,
               y1:d[0][1], y2:d[1][1]}))).enter()
    .append("g");
lines.append("line")
    .attrs({stroke:"black", "stroke-width":5, "stroke-linecap":"round"})
    .attr("marker-end", l=>"url(#arrow)")
    .attrs(l=>l);

function getbox(d) {
    var w=60, h=80;
    return {x:d.x-w/2, y:d.y-h/2, width:w, height:h,
            "stroke-width":2, stroke:"black",
            fill : d.load ? "yellow" : "#eee"};
    return a;
}

var boxes = svg.selectAll().data([
        {text:"⍵"            , pos:w(0)   , w:46},
        {text:"⍵"            , pos:w(1)   , w:46},
        {text:"⍋"            , pos:g(0)   , w:46},
        {text:"⍋"            , pos:g(1)   , w:46},
        {text:"⊃"            , pos:r(0)   , w:46},
        {text:"⊃"            , pos:r(1)   , w:46, load:1},

        {text:"⊃⍋⍵"          , pos:int2(0)},
        {text:"⊃⍋⍵"          , pos:int2(1)},

        {text:"⍋⍵"           , pos:int1(0)},
        {text:'"⍋⍵"'         , pos:int1(1)},

        {text:'⍵⍳⌊/⍵'        , pos:[i0,j2+80]},
    ].map(d=>{d.x=d.pos[0]; d.y=d.pos[1]; return d})).enter();
boxes.append("rect").filter(d=>d.w)
    .attrs(getbox);
boxes.append("text")
    .attr("text-anchor", "middle")
    .attrs(d=>{
        var fs=d.w?60:46;
        return {x:d.x, y:d.y+fs/3, fill:d.fill, "font-size":fs, "font-family":"monospace"};
    })
    .text(d=>d.text);

var rects = svg.selectAll().data([[j1-80,j2-80], [j2-80,j2+50], [j2+50,j2+120]]).enter()
    .append("rect")
    .attrs(d=>({x:0, width:900, y:d[0], height:d[1]-d[0], fill:"white", opacity:1}));

var step = 0;
document.onclick = function() {
    if (step<2)
        d3.selectAll("li").filter((_,i)=>i===step).style("opacity",1);
    else
        rects.filter((_,i)=>i===step-2).transition().duration(500).attr("opacity",0);
    step++;
}
