var i0  =     120,
    i2  = i0 +220,
    i4  = i2 +460,
    i3  = (i2+i4)/2 + 50,
    i1  = (i0+i3)/2,
    ie  = (i0+i2)/2;

var j0 =     26,
    j1 = j0+ 80,
    j2 = j1+150,
    j3 = j2+104,
    j4 = j3+ 90,
    j5 = j4+120,
    j6 = j5+100;

var svg = d3.select("#svg"),
    defs = svg.append("defs");

defs.append("filter").attrs({id:"blur", x:-1,width:3,y:-0.2,height:1.4})
    .append("feGaussianBlur").attr("stdDeviation",30);

var paths = svg.selectAll().data([
        [i2- 50, j0,   i0+70, j2   ,   i0   , j2,   i0+30, j6],
        [i2+160, j0,   i3   , j5   ,   i2+20, j2,   i2   , j6],
        [i2+220, j0,   i3+20, j4+80,   i4-20, j3,   i4   , j6],
    ].map(d=>
        Array.from("M C , , ").map((c,i)=>c+d[i]).join("")
    )).enter().append("g");
paths.append("mask").attrs({x:-1,width:3,y:-0.2,height:1.4}).attr("id",(_,i)=>"pathMask"+i)
    .append("path")
    .attr("stroke", "white")
    .attr("stroke-width", 120)
    .attr("fill", "none")
    .attr("d", d=>d);
paths.append("path")
    .attr("mask", (_,i)=>"url(#pathMask"+i+")")
    .attr("filter", "url(#blur)")
    .attr("stroke", "#dccfec")
    .attr("stroke-width", 100)
    .attr("fill", "none")
    .attr("d", d=>d);

var lines = svg.selectAll().data([
        {x1:i0 , x2:i0 ,  y1:j2, y2:j3, "stroke-width":15, stroke:"#ddd", bg:"#999", "stroke-dasharray":"21,20"},
        {x1:i3 , x2:i3 ,  y1:j2, y2:j3, "stroke-width":15, stroke:"#ddd", bg:"#999", "stroke-dasharray":"21,20"},

        {x1:i1 , x2:i1 ,  y1:j0, y2:j1, raise:1},
        {x1:i0 , x2:i0 ,  y1:j1, y2:j2},
        {x1:i3 , x2:i3 ,  y1:j1, y2:j2},
        {x1:i1 , x2:i1 ,  y1:j2, y2:j3, raise:1},
        {x1:i0 , x2:i0 ,  y1:j3, y2:j5},
        {x1:i3 , x2:i3 ,  y1:j3, y2:j4},
        {x1:i2 , x2:i2 ,  y1:j4, y2:j5},
        {x1:i4 , x2:i4 ,  y1:j4, y2:j6-16, raise:1},
        {x1:ie , x2:ie ,  y1:j5, y2:j6+12, raise:1},

        {x1:i0 , x2:i3 ,  y1:j1, y2:j1},
        {x1:i0 , x2:i3 ,  y1:j2, y2:j2},
        {x1:i0 , x2:i3 ,  y1:j3, y2:j3},
        {x1:i2 , x2:i4 ,  y1:j4, y2:j4},
        {x1:i0 , x2:i2 ,  y1:j5, y2:j5}
    ]).enter();
lines.filter(l=>l.bg)
    .append("line")
    .attr("stroke-linecap", "round")
    .attrs(l=>l)
    .attrs(l=>({"stroke-width": 2+l["stroke-width"], stroke:l.bg}));
var l0 = lines.append("line")
    .attr("stroke", "black")
    .attr("stroke-width", 5)
    .attr("stroke-linecap", "round")
    .attrs(l=>l);

var fns = svg.selectAll().data([
        [i0, j1, i3+60, j2   , "#e9f02b"],
        [i0, j3, i4+10, j6-44, "#39f739"],
    ].map(d=>{d[0]-=70;d[2]+=70; d[1]-=60;d[3]+=20; return d})).enter();
fns.append("rect")
    .attrs(d=>({x:d[0], width:d[2]-d[0], y:d[1], height:d[3]-d[1],
                fill:"none", stroke:d[4], "stroke-width":7, opacity:0.75}));
fns.append("text")
    .attrs(d=>({x:d[2]-6,y:d[1]+30, "text-anchor":"end", "font-size":28, fill:d[4]}))
    .text((_,i) => "function "+(i+1));

l0.filter(l=>l.raise).raise();

var ev0 = "#f3f781",
    ev1 = "#9e9",
    cost= "#e11";

defs.append("linearGradient").attr("id", "ev01")
    .selectAll().data([ev0,ev1]).enter()
    .append("stop").attr("offset",(_,i)=>i).attr("stop-color",c=>c);

var boxes = svg.selectAll().data([
        {text:"size check"   , cost:"<0.5ns",  x:i1, y:j1,        w:200, left:"small", right:"large"},

        {text:"make thunk"   , cost:"10–15ns", x:i3, y:(j1+j2)/2, w:220},
        {text:"evaluate"     ,                 x:i0+20, y:(j1+j2)/2, w:160, fill:ev0},

        {text:"is a thunk?"  , cost:"0ns",     x:i1, y:j3,        w:200, left:"no", right:"yes"},

        {text:"special code?", cost:"0–5ns",   x:i3, y:j4,        w:240, left:"no", right:"yes"},
        {text:"expand thunk" , cost:"10–20ns", x:i2, y:(j4+j5)/2, w:250, fill:ev0},
        {text:"eval"         ,                 x:i4-10, y:j5-16,     w:120, h:80, fill:"url(#ev01)"},
        {text:"both"         ,                 x:i4-10, y:j5+ 2},

        {text:"evaluate"     ,                 x:ie, y:j5+38,     w:160, fill:ev1},
    ]).enter();

boxes.filter(d=>d.w)
    .append("rect").attrs(function (d) {
        var w=d.w, h=d.h||(d.cost?72:42);
        return {x:d.x-w/2, y:d.y-h/2, width:w, height:h,
                "stroke-width":2, stroke:"black", fill:d.fill||"#f0eee9"};
    });
boxes.append("text")
    .attr("text-anchor", "middle")
    .attrs(d=>{
        var fs=d["font-size"]||34,
            a = {x:d.x, y:d.y+fs/3-(d.h?(d.h-42)/2:d.cost?14:0), "font-size":fs};
        return a;
    })
    .text(d=>d.text);

boxes.filter(d=>d.cost)
    .append("text")
    .attr("text-anchor", "middle")
    .attrs(d=>({x:d.x, y:d.y+28, "font-size":26, fill:cost}))
    .text(d=>d.cost);

boxes.filter(d=>d.left).selectAll()
    .data(d=>{
        var o = d.w/2+6,
            y = d.y-7;
        return [{a:"end"  , x:d.x-o, y:y, t:d.left },
                {a:"start", x:d.x+o, y:y, t:d.right}]
    }).enter()
    .append("text")
    .attr("text-anchor", e=>e.a)
    .attrs(e=>({x:e.x, y:e.y, "font-size":22, fill:"#666"}))
    .text(e=>e.t);

svg.selectAll().data([
        {x:i0+32, cost:"<0.5ns" },
        {x:i2- 4, cost:"20–40ns"},
        {x:i4   , cost:"faster!"},
    ]).enter()
    .append("text")
    .attrs(e=>({x:e.x, y:j6+16, "text-anchor":"middle", "font-size":32, fill:cost}))
    .text(e=>e.cost);
